#pragma once

#include "GtNode.h"

class GtCamera : public GtNode
{
public:
	enum eGT_CAMERATYPE
	{
		eCM_LANDMOVE,
		eCM_AIRMOVE,

		eCM_END
	};

private:
	eGT_CAMERATYPE	m_eCameraType;

	GtPoint3f		m_vRight;
	GtPoint3f		m_vUp;
	GtPoint3f		m_vLook;

public:
	GtCamera(void);
	GtCamera(eGT_CAMERATYPE eCameraType);
	virtual ~GtCamera(void);

	void SetCameraType(eGT_CAMERATYPE eCameraType);
	void Reset(void);

	void Walk(float value);							//  ڷ ̵
	void Strafe(float value);						//   ̵
	void Fly(float value);							//  Ʒ ̵

	virtual			void		RotationPitch(const float angle, eGT_TransformSpace relativeTo = eTS_LOCAL);	// x ȸ
	virtual			void		RotationYaw(const float angle, eGT_TransformSpace relativeTo = eTS_LOCAL);		// y ȸ
	virtual			void		RotationRoll(const float angle, eGT_TransformSpace relativeTo = eTS_LOCAL);		// z ȸ

	void GetViewMatrix(GtMatrix4* pMat);		// Right, Up, Look  ȸ  ڿ  Ŀ 
	
	//   Լ
	void GetRight(GtPoint3f *pt);
	void GetUp(GtPoint3f *pt);
	void GetLook(GtPoint3f *pt);
};