#pragma once

#include "GtSoftwareRender_Type.h"

#pragma pack(push, 2)		// 2byte    4Ʈ  ȴ.
typedef struct sGT_DIB_File_Header
{
	unsigned short		usType;
	unsigned long		ulsize;
	unsigned short		usReserved1;
	unsigned short		usReserved2;
	unsigned long		ulOffBits;
}GT_DIB_FILE_HEADER, *LPGTDIB_FILE_HEADER;
#pragma pack(pop)

typedef struct sGT_DIB_Info_Header
{
	unsigned long  ulSize;
	long           lWidth;
	long           lHeight;
	unsigned short usPlanes;
	unsigned short usBitCount;
	unsigned long  ulCompression;
	unsigned long  ulSizeImage;
	long           lXPelsPerMeter;
	long           lYPelsPerMeter;
	unsigned long  ulClrUsed;
	unsigned long  ulClrImportant;
}GT_DIB_INFO_HEADER, *LPGT_FILE_INFO_HEADER;

typedef struct sGT_RGBQUAD
{
	unsigned char ucBlue;
	unsigned char ucGreen;
	unsigned char ucRed;
	unsigned char cReserved;
}GT_RGBQUAD, *LPGT_RGBQUAD;

class GtDIB
{
private:
	void*				m_pBuff;
	unsigned int		m_nBuffOffset;
	GT_DIB_FILE_HEADER	m_FileHeader;
	GT_DIB_INFO_HEADER	m_InfoHeader;
	GT_RGBQUAD			m_RgbQuad;
	unsigned char*		m_pBitmapBuff;

public:
	GtDIB(void* pBuff = NULL, unsigned int uiBuffOffset = 1);
	~GtDIB(void);
public:
	bool				LoadDIBBitmap(const char *pName);
	void				DrawBitmap(int x, int y);
	void				SetBuff(void* pBuff, unsigned int nBuffOffset);
	int					GetUVPixel(float u, float v);
	int					GetPosPixel(int x, int y);
};