#pragma once


//-------------------------------------------------------------------
// Flexible vertex format bits
// DirectX 
#define GT_FVF_NONE				0
#define GT_FVF_RESERVED0        0x001
#define GT_FVF_POSITION_MASK    0x400E
#define GT_FVF_XYZ              0x002
#define GT_FVF_XYZRHW           0x004
#define GT_FVF_XYZB1            0x006
#define GT_FVF_XYZB2            0x008
#define GT_FVF_XYZB3            0x00a
#define GT_FVF_XYZB4            0x00c
#define GT_FVF_XYZB5            0x00e
#define GT_FVF_XYZW             0x4002

#define GT_FVF_NORMAL           0x010
#define GT_FVF_PSIZE            0x020
#define GT_FVF_DIFFUSE          0x040
#define GT_FVF_SPECULAR         0x080

#define GT_FVF_TEXCOUNT_MASK    0xf00
#define GT_FVF_TEXCOUNT_SHIFT   8
#define GT_FVF_TEX0             0x000
#define GT_FVF_TEX1             0x100
#define GT_FVF_TEX2             0x200
#define GT_FVF_TEX3             0x300
#define GT_FVF_TEX4             0x400
#define GT_FVF_TEX5             0x500
#define GT_FVF_TEX6             0x600
#define GT_FVF_TEX7             0x700
#define GT_FVF_TEX8             0x800

#define GT_FVF_LASTBETA_UBYTE4   0x1000
#define GT_FVF_LASTBETA_D3DCOLOR 0x8000

#define GT_FVF_RESERVED2         0x6000  // 2 reserved bits
//-------------------------------------------------------------------

#define GT_FVF_TEXTUREFORMAT2 0         // Two floating point values
#define GT_FVF_TEXTUREFORMAT1 3         // One floating point value
#define GT_FVF_TEXTUREFORMAT3 1         // Three floating point values
#define GT_FVF_TEXTUREFORMAT4 2         // Four floating point values

#define GT_FVF_TEXCOORDSIZE3(CoordIndex) (GT_FVF_TEXTUREFORMAT3 << (CoordIndex*2 + 16))
#define GT_FVF_TEXCOORDSIZE2(CoordIndex) (GT_FVF_TEXTUREFORMAT2)
#define GT_FVF_TEXCOORDSIZE4(CoordIndex) (GT_FVF_TEXTUREFORMAT4 << (CoordIndex*2 + 16))
#define GT_FVF_TEXCOORDSIZE1(CoordIndex) (GT_FVF_TEXTUREFORMAT1 << (CoordIndex*2 + 16))

#define FVF_SIZE_FLOAT(n,name) typedef struct s##name { float f[##n]; } s##name;

#define FVF_SIZE_ULONG(n,name) typedef struct s##name { unsigned long ul[##n]; } s##name;

FVF_SIZE_FLOAT(3,GT_FVF_XYZ);
FVF_SIZE_FLOAT(4,GT_FVF_XYZRHW);
FVF_SIZE_FLOAT(1,GT_FVF_XYZB1);
FVF_SIZE_FLOAT(2,GT_FVF_XYZB2);
FVF_SIZE_FLOAT(3,GT_FVF_XYZB3);
FVF_SIZE_FLOAT(4,GT_FVF_XYZB4);
FVF_SIZE_FLOAT(5,GT_FVF_XYZB5);
FVF_SIZE_FLOAT(3,GT_FVF_NORMAL);
FVF_SIZE_ULONG(1,GT_FVF_DIFFUSE);
FVF_SIZE_ULONG(1,GT_FVF_SPECULAR);

class GtFVF
{
public:
	int					FVF_Get_Total_Size(unsigned long _value);
	int					FVF_Get_SizeOf(unsigned long _FVF);
	//  Ϳ FVF Ӽ   Ӽ ͷ ̵
	//  FVF,  FVF, ޽ FVF Ӽ,   
	void*               NextValue(unsigned long _Start_FVF_Flag,unsigned long _Target_FVF_Flag);
	void				NextNode(void); //   ̵
	void				ResetPtr(void);// ٽ óġ ͸ ̵Ѵ.
	void				ReMakePtr(void* _Ptr); // FVF ٽ Ѵ.
	void                ReMakeFVF(unsigned long _FVF_VALUE);
	
	inline bool         IsFVF(unsigned long FVF_Flag);
	const unsigned long GetFVF(void);

private:
	void*			    m_pOriginal; //  ͸  
	unsigned long	    m_FVF_Value; // FVF Ӽ
	unsigned long	    m_FVF_Size;  // FVF 
	char*			    m_pCalc; // ӽ  ()
	char*			    m_pNext; //   ̵ϱ  
public:
	GtFVF();
	~GtFVF();
};