#pragma once

#include "GtPoint3.h"
#include "GtPlane.h"
#include "GtSphere.h"
#include "GtObjUseFunc.h"

#define PLANE_EPSILON	5.0f

class GtFrustum
{
private:
	GtPoint3f		m_ptFrustumPoint[8];	// Frustum  8 
	GtPlane			m_Plane[6];				// Frustum  6 

	GtPoint3f		m_vPos;
public:
	GtPoint3f		GetPosition(void);
	void			SetPosition(GtPoint3f &pos);
	bool			MakeFrustum(GtMatrix4& matView, GtMatrix4& matProj);
	int				StateSphereFrustum(GtSphere& in);
	bool			StatePolygonFrustum(GtPoint3f& _a, GtPoint3f& _b, GtPoint3f& _c);
	bool			IsInPoint(GtPoint3f *pV);
};