#pragma once

#include "GtSoftwareRenderDevice.h"

struct VERTEX
{
	GtPoint3f pos;
	int		color;

	VERTEX(){}
	VERTEX(GtPoint3f& _pos,int _color) : pos(_pos),color(_color) {}
};

struct VERTEX2
{
	GtPoint3f pos;
	GtPoint3f normal;
	float   u,v;

	static const int FVF = GT_FVF_XYZ|GT_FVF_NORMAL|GT_FVF_TEX1;
	VERTEX2(){}
	VERTEX2(GtPoint3f& _pos,GtPoint3f& _normal,float _u = 0,float _v = 1) : pos(_pos),normal(_normal),u(_u),v(_v) {}
};

class GtMainClass
{
private:
private:
	GtSoftwareRenderDevice	*m_pSwrRenderer;
	GtTexture				*m_pTexture;
	GtVertexBuffer			*m_pVB;
	VERTEX2					m_Box[24];

	GtPoint3f				m_fMesh2Position;

public:
	GtMainClass(void);
	~GtMainClass(void);

	void			InitMainClass(HWND hWnd);
	void			ReleaseMainClass(HWND hWnd);

	void			MainFlip(void);
	void			MainRender(void);
	void			MainProcess(void);

	// Render, Process, Flip
	void			MainFrame(void);
};