
inline void GtMatrix4::GetRow(unsigned int uiRow, GtPoint4f& row) const
{
	row.SetX(m[uiRow][0]);
	row.SetY(m[uiRow][1]);
	row.SetZ(m[uiRow][2]);
	row.SetW(m[uiRow][3]);
}

inline void GtMatrix4::GetRow(unsigned int uiRow, GtPoint3f& row) const
{
	row.x = m[uiRow][0];
	row.y = m[uiRow][1];
	row.z = m[uiRow][2];
}

inline void GtMatrix4::SetRow(unsigned int uiRow, const GtPoint4f& row)
{
	m[uiRow][0] = row.X();
	m[uiRow][1] = row.Y();
	m[uiRow][2] = row.Z();
	m[uiRow][3] = row.W();
}

inline void GtMatrix4::SetRow(unsigned int uiRow, const GtPoint3f& row)
{
	m[uiRow][0] = row.x;
	m[uiRow][1] = row.y;
	m[uiRow][2] = row.z;
}

inline void GtMatrix4::GetRow(unsigned int uiRow, float& f0, float& f1, float& f2) const
{
	f0 = m[uiRow][0];
	f1 = m[uiRow][1];
	f2 = m[uiRow][2];
}
inline void GtMatrix4::SetRow(unsigned int uiRow, float f0, float f1, float f2)
{
	m[uiRow][0] = f0;
	m[uiRow][1] = f1;
	m[uiRow][2] = f2;
}
inline void GtMatrix4::GetRow(unsigned int uiRow, float* pRow) const
{
	if(sizeof(pRow) == 16)
	{
		pRow[0] = m[uiRow][0];
		pRow[1] = m[uiRow][1];
		pRow[2] = m[uiRow][2];
		pRow[3] = m[uiRow][3];
	}
	else if(sizeof(pRow) == 12)
	{
		pRow[0] = m[uiRow][0];
		pRow[1] = m[uiRow][1];
		pRow[2] = m[uiRow][2];
	}
}
inline void GtMatrix4::SetRow(unsigned int uiRow, const float* pRow)
{
	if(sizeof(pRow) == 16)
	{
		m[uiRow][0] = pRow[0];
		m[uiRow][1] = pRow[1];
		m[uiRow][2] = pRow[2];
		m[uiRow][3] = pRow[3];
	}
	else if(sizeof(pRow) == 12)
	{
		m[uiRow][0] = pRow[0];
		m[uiRow][1] = pRow[1];
		m[uiRow][2] = pRow[2];
	}
}

inline void GtMatrix4::GetCol(unsigned int uiCol, GtPoint4f& col) const
{
	col.SetX(m[uiCol][0]);
	col.SetY(m[uiCol][1]);
	col.SetZ(m[uiCol][2]);
	col.SetW(m[uiCol][3]);
}

inline void GtMatrix4::GetCol(unsigned int uiCol, GtPoint3f& col) const
{
	col.x = m[uiCol][0];
	col.y = m[uiCol][1];
	col.z = m[uiCol][2];
}

inline void GtMatrix4::SetCol(unsigned int uiCol, const GtPoint4f& col)
{
	m[uiCol][0] = col.X();
	m[uiCol][1] = col.Y();
	m[uiCol][2] = col.Z();
	m[uiCol][3] = col.W();
}
inline void GtMatrix4::SetCol(unsigned int uiCol, const GtPoint3f& col)
{
	m[uiCol][0] = col.x;
	m[uiCol][1] = col.y;
	m[uiCol][2] = col.z;
}
inline void GtMatrix4::GetCol(unsigned int uiCol, float& f0, float& f1, float& f2)
{
	f0 = m[uiCol][0];
	f1 = m[uiCol][1];
	f2 = m[uiCol][2];
}
inline void GtMatrix4::SetCol(unsigned int uiCol, float f0, float f1, float f2)
{
	m[uiCol][0] = f0;
	m[uiCol][1] = f1;
	m[uiCol][2] = f2;
}
inline void GtMatrix4::GetCol(unsigned int uiCol, float* pCol) const
{
	if(sizeof(pCol) == 16)
	{
		pCol[0] = m[uiCol][0];
		pCol[1] = m[uiCol][1];
		pCol[2] = m[uiCol][2];
		pCol[3] = m[uiCol][3];
	}
	else if(sizeof(pCol) == 12)
	{
		pCol[0] = m[uiCol][0];
		pCol[1] = m[uiCol][1];
		pCol[2] = m[uiCol][2];
	}
}
inline void GtMatrix4::SetCol(unsigned int uiCol, const float* pCol)
{
	if(sizeof(pCol) == 16)
	{
		m[uiCol][0] = pCol[0];
		m[uiCol][1] = pCol[1];
		m[uiCol][2] = pCol[2];
		m[uiCol][3] = pCol[3];
	}
	else if(sizeof(pCol) == 12)
	{
		m[uiCol][0] = pCol[0];
		m[uiCol][1] = pCol[1];
		m[uiCol][2] = pCol[2];
	}
}