#include "GtPicking.h"

//------------------------------------------------------------------------
// Լ  : sGT_HALFLINE CreateHalfLine(LPDIRECT3DDEVICE9 m_pDev, HWND hWnd, int iX, int iY)
//     : ȭ Ʈ(ġ)   Ʈ ȯ
//     : pDev : DirectX ̽, hWnd : ũ ũ⸦ Ȯ ڵ
//		     iX, iY : ػ
//     : ڷ  ̽  ϰ,
//			 ڵ â ũ⸦ µ
//			 ػ x, y    ũ  ǥ
//			 â ǥ ȯ ش.
//------------------------------------------------------------------------
sGT_HALFLINE GtPicking::CreateHalfLine(LPDIRECT3DDEVICE9 m_pDev, HWND hWnd, int iX, int iY)
{
	// Ʈ  
	D3DVIEWPORT9 ViewPort;
	m_pDev->GetViewport(&ViewPort);

	//   
	D3DXMATRIX matProj;
	m_pDev->GetTransform(D3DTS_PROJECTION, &matProj);

	RECT rt;
	GetClientRect(hWnd, &rt);

	GtPoint3f v;
    v.x = ((  (((iX - rt.left ) * 2.0f / rt.right ) - 1.0f)) - matProj._31 ) / matProj._11;
    v.y = ((- (((iY - rt.top ) * 2.0f / rt.bottom) - 1.0f)) - matProj._32 ) / matProj._22;
    v.z = 1.0f;

	//  
	D3DXMATRIX matView;
	m_pDev->GetTransform(D3DTS_VIEW, &matView);
	D3DXMATRIX m;
	D3DXMatrixInverse(&m, NULL, &matView);

	//ŷ () 3 ̵
	m_sHL.m_vDir.x = v.x * m._11 + v.y * m._21 + v.z * m._31;
	m_sHL.m_vDir.y = v.x * m._12 + v.y * m._22 + v.z * m._32;
	m_sHL.m_vDir.z = v.x * m._13 + v.y * m._23 + v.z * m._33;
	m_sHL.m_vOri.x = m._41;
	m_sHL.m_vOri.y = m._42;
	m_sHL.m_vOri.z = m._43;

	return m_sHL;
}

//------------------------------------------------------------------------
// Լ  : bool TransformHalfLine(GT_HALFLINE *pHL, D3DXMATRIX *pT)
//     :    ͸  
//     : pHL : , pT :  
//     : ڷ     ͸ İ 
//------------------------------------------------------------------------
void GtPicking::TransformHalfLine(GT_HALFLINE *pHL, D3DXMATRIX *pT)
{
	// ̶  Ѵ
	D3DXVec3TransformCoord(&pHL->m_vOri, &pHL->m_vOri, pT);

	// ⺤Ϳ  
	D3DXVec3TransformNormal(&pHL->m_vDir, &pHL->m_vDir, pT);
}

//------------------------------------------------------------------------
// Լ  : bool CheckPlaneCollision(D3DXVECTOR3 vNormal, float fD)
//     : ̶  浹 üũ
//     : vNormal , fD Ÿ
//     : ڷ  Ϳ Ÿ  ġ 
//------------------------------------------------------------------------
bool GtPicking::CheckPlaneCollision(D3DXVECTOR3 vNormal, float fD)
{
	//   Ͷ   ͸ 
	float fDist = D3DXVec3Dot(&m_sHL.m_vDir, &vNormal);

	//   0̸   
	if(0 == fDist)
		return false;

	//      Ÿ شϴ ġ 
	m_sHL.m_fT = ((fD - D3DXVec3Dot(&m_sHL.m_vOri, &vNormal)) / fDist);
	m_vPickPos = m_sHL.m_vOri + m_sHL.m_vDir * m_sHL.m_fT;
	return true;
}


//------------------------------------------------------------------------
// Լ  : bool CheckShpereCollision(D3DXVECTOR3 vCenter, float fRadian)
//     :  ü 浹üũ
//     : vNormal  ,  
//     : ڷ     浹 ߴ ˻
//------------------------------------------------------------------------
bool GtPicking::CheckShpereCollision(D3DXVECTOR3 vCenter, float fRadian)
{
	//    ߽  Ÿ 
	D3DXVECTOR3 vS = (m_sHL.m_vOri - vCenter);
	
	//  浹 Ÿ  2  ̿  a,b,c  ϱ
	float fA = D3DXVec3Dot(&m_sHL.m_vDir, &m_sHL.m_vDir);		// |m_vDir| 2
	float fB = 2.0f * D3DXVec3Dot(&m_sHL.m_vDir, &vS);		// 2V * (S-Center)
	float fC = D3DXVec3Dot(&vS, &vS) - (fRadian * fRadian);
	
	float fDisc = (fB * fB) - (4.0f * fA * fC);
	if(0.0001f > fDisc)
		return false;
	else if(fDisc == 0)
	{
		m_vPickPos = m_sHL.m_vDir * (-fB / (2.0f * fA));
		return true;
	}

	else
	{
		fDisc = sqrtf(fDisc);
		float T1 = ((-fB) - fDisc) / (2.0f * fA);
		float T2 = ((-fB) + fDisc) / (2.0f * fA);

		//     ã
		if(T1 < T2)
			m_sHL.m_fT = T1;
		else
			m_sHL.m_fT = T2;

		m_vPickPos = m_sHL.m_vOri + m_sHL.m_vDir * m_sHL.m_fT;
		return true;
	}
	return false;
}

//------------------------------------------------------------------------
// Լ  : bool CheckTriangleCollision(D3DXVECTOR3 &v0, D3DXVECTOR3 &v1, D3DXVECTOR3 &v2)
//     :  ﰢ 浹üũ
//     : v0 : IndexBuffer  ﰢ ù 
//		     v1 : IndexBuffer  ﰢ ι° 
//		     v2 : IndexBuffer  ﰢ ° 
//     : ڷ  3  ̷ִ ﰢ
//		     ŷ Ǿ üũ
//------------------------------------------------------------------------
bool GtPicking::CheckTriangleCollision(D3DXVECTOR3 &v0, D3DXVECTOR3 &v1, D3DXVECTOR3 &v2)
{
	D3DXVECTOR3 vecP;
	D3DXVECTOR3 vecE1	= v1 - v0;
	D3DXVECTOR3 vecE2	= v2 - v0;

	D3DXVec3Cross( &vecP, &m_sHL.m_vDir, &vecE2 );
	float fDet	= D3DXVec3Dot( &vecE1, &vecP );
	if( fDet > -0.0001f && fDet < 0.0001f )
		return false;

	float fInvDet = 1.0f / fDet;
	D3DXVECTOR3	vecS	= m_sHL.m_vOri - v0;
	float u	= fInvDet * D3DXVec3Dot( &vecP, &vecS );
	if( u < 0.0f || u > 1.0f )
		return false;

	D3DXVECTOR3 vecQ;
	D3DXVec3Cross( &vecQ, &vecS, &vecE1 );
	float v	= fInvDet * D3DXVec3Dot( &vecQ, &m_sHL.m_vDir );
	if( v < 0.0f || (u + v) > 1.0f )
		return false;

	m_sHL.m_fT	= fInvDet * D3DXVec3Dot( &vecQ, &vecE2 );
	if(m_sHL.m_fT < 0.0f)
		return false;

	m_vPickPos	= m_sHL.m_vOri+ m_sHL.m_vDir * m_sHL.m_fT;
	return true;
}