#pragma once

#include "GtMath.h"

// x,y 2 ¥ ü
template<typename T>
class GtPoint2
{
public:
	T x, y;

	GtPoint2<T>() { }
	GtPoint2<T>(T x, T y);

	T& operator[] (int i)
	{
		const T *base = &x;
		return (T&) base[i];
	}

	const T& operator[] (int i) const
	{
		const T *base = &x;
		return (T&) base[i];
	}

	bool operator == (const GtPoint2<T>& pt) const;
	bool operator != (const GtPoint2<T>& pt) const;

	GtPoint2<T>			operator+(const GtPoint2<T>& pt) const;
	GtPoint2<T>			operator-(const GtPoint2<T>& pt) const;
	T					operator*(const GtPoint2<T>& pt) const;
	GtPoint2<T>			operator*(T tScalar) const;
	GtPoint2<T>			operator/(T tScalar) const;
	GtPoint2<T>			operator-() const;

	static GtPoint2<T>	ComponentProduct(const GtPoint2<T>& p0, const GtPoint2<T>& p1);

	GtPoint2<T>			operator+=(const GtPoint2<T>& pt);
	GtPoint2<T>			operator-=(const GtPoint2<T>& pt);
	GtPoint2<T>			operator*=(T tScalar);
	GtPoint2<T>			operator/=(T tScalar);

	float				Length() const;
	float				SqrLength() const;
	float				Dot(const GtPoint2<T> &pt) const;
	float				Unitize();	
};

typedef GtPoint2<int>		GtPoint2i;
typedef GtPoint2<float>		GtPoint2f;

#include "GtPoint2.inl"