#include<assert.h>

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T>::GtPoint4()
{
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T>::GtPoint4(T tX, T tY, T tZ, T tW)
{
	Set(tX, tY, tZ, tW);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T>::GtPoint4(const GtPoint3<T>& pt, T tW)
{
	Set(pt, tW);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::MakeZero()
{
	Set(0, 0, 0, 0);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::Set(T tX, T tY, T tZ, T tW)
{
	SetX(tX);
	SetY(tY);
	SetZ(tZ);
	SetW(tW);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::Set(const GtPoint3<T>& pt, T tW)
{
	Set(pt.x, pt.y, pt.z tW);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::Set3VectorW0(const GtPoint3<T>& pt)
{
	Set(pt, 0);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::Set3VectorW0(T tX, T tY, T tZ)
{
	Set(tX, tY, tZ, 0);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline T GtPoint4<T>::operator [] (int i) const
{
	assert(i >= 0);
	assert(i <  4);
	return m_afPt[i];
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline T GtPoint4<T>::Set(unsigned int uiComponent, T tValue)
{
	assert(uiComponent < 4);
	m_afPt[uiComponent] = tValue;
	return tValue;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline T GtPoint4<T>::X() const
{
	return (*this)[0];
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline T GtPoint4<T>::Y() const
{
	return (*this)[1];
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline T GtPoint4<T>::Z() const
{
	return (*this)[2];
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline T GtPoint4<T>::W() const
{
	return (*this)[3];
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::SetX(T tX)
{
	m_afPt[0] = tX;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::SetY(T tY)
{
	m_afPt[1] = tY;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::SetZ(T tZ)
{
	m_afPt[2] = tZ;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::SetW(T tW)
{
	m_afPt[3] = tW;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator -() const
{
	return (*this) * -1;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator +(const GtPoint4<T>& pt) const
{
	GtPoint4<T> result = *this;
	result += pt;
	return result;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator -(const GtPoint4<T>& pt) const
{
	GtPoint4<T> result = *this;
	result -= pt;
	return result;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator *(T tScalar) const
{
	GtPoint4<T> result = *this;
	result *= tScalar;
	return result;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator /(T tScalar) const
{
	GtPoint4<T> result = *this;
	result /= tScalar;
	return result;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator +=(const GtPoint4<T>& pt)
{
	m_afPt[0] += pt.m_afPt[0];
	m_afPt[1] += pt.m_afPt[1];
	m_afPt[2] += pt.m_afPt[2];
	m_afPt[3] += pt.m_afPt[3];
	return *this;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator -=(const GtPoint4<T>& pt)
{
	m_afPt[0] -= pt.m_afPt[0];
	m_afPt[1] -= pt.m_afPt[1];
	m_afPt[2] -= pt.m_afPt[2];
	m_afPt[3] -= pt.m_afPt[3];
	return *this;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator *=(T tScalar)
{
	m_afPt[0] *= tScalar;
	m_afPt[1] *= tScalar;
	m_afPt[2] *= tScalar;
	m_afPt[3] *= tScalar;
	return *this;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline GtPoint4<T> GtPoint4<T>::operator /=(T tScalar)
{
	m_afPt[0] /= tScalar;
	m_afPt[1] /= tScalar;
	m_afPt[2] /= tScalar;
	m_afPt[3] /= tScalar;
	return *this;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline bool GtPoint4<T>::operator ==(const GtPoint4<T>& pt) const
{
	return 
		pt.m_afPt[0] == m_afPt[0] &&
		pt.m_afPt[0] == m_afPt[1] &&
		pt.m_afPt[0] == m_afPt[2] &&
		pt.m_afPt[0] == m_afPt[3];
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline bool GtPoint4<T>::operator !=(const GtPoint4<T>& pt) const
{
	bool bEquals = (*this)==pt;
	return !bEquals;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::CompressNormalizedIntoXY(const GtPoint3<T>& pt)
{
	assert(pt.z > 0.0f);

	T factor = ((T)1.0f) / point.z;
	SetX(point.x * factor);
	SetY(point.y * factor);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::CompressNormalizedIntoZW(const GtPoint3<T>& pt)
{
	assert(pt.z > 0.0f);

	T factor = ((T)1.0f) / point.z;
	SetZ(point.x * factor);
	SetW(point.y * factor);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::DecompressXYIntoNormalized(GtPoint3<T>& pt)
{
	pt.x = X();
	pt.y = Y();
	pt.z = 1.0f;
	pt.Unitize();
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::DecompressZWIntoNormalized(GtPoint3<T>& pt)
{
	pt.x = Z();
	pt.y = W();
	pt.z = 1.0f;
	pt.Unitize();
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
template<typename T>
inline void GtPoint4<T>::DecompressHighDetailIntoNormalized(GtPoint3<T>& pt)
{
    if (W() == FLT_MAX)
    {
        pt.x = X();
        pt.y = Y();
        pt.z = Z();
    }
    else
    {
        pt.x = X();
        pt.y = Y();
        pt.z = 1.0f;
    }
    pt.Unitize();
}
//------------------------------------------------------------------------------------