#pragma once

#include "GtNode.h"
#include "GtSphere.h"
#include "GtFrustum.h"
#include "GtTerrain.h"

#define CENTER_INDEX(a, b, c, d) (a + b + c + d)/4

class GtQuadTree
{
	enum eFRUSTUMSTATE
	{
		eFS_OUT,
		eFS_PARTIALLY_IN,
		eFS_COMPLETELY_IN,
		eFS_UNKNOWN = -1,
	};

	enum eCOURSE
	{
		eCS_UP,
		eCS_DN,
		eCS_LT,
		eCS_RT,

		eCS_END
	};

	enum eCORNER
	{
		eCN_TL,
		eCN_TR,
		eCN_BL,
		eCN_BR,

		eCN_END
	};
private:
	GtQuadTree*		m_pNeighbor[4];		// ̿
	GtQuadTree*		m_pChild[4];		// ڽĳ

private:
	int				m_nCenter;			// 簢 ߽ ε
	int				m_nCorner[4];		// 簢  ڳ ε
	float			m_fRadius;			// 豸 
	GtSphere		m_spSphere;			// 豸
	bool			m_bCulled;			//  ø üũ

public:
	GtQuadTree(int iX, int iY);			//  Ʈ 
	GtQuadTree(void);					//  Ʈ 
	virtual ~GtQuadTree(void);			// Ҹ

private:
	GtQuadTree*	AddChild(int iCornerTL, int iCornerTR, int iCornerBL, int iCornerBR);
	void		SetCorners(int iCornerTL, int iCornerTR, int iCornerBL, int iCornerBR);

public:
	void		Build(LPGT_CUSTOMVERTEX	pHeightMap);
	void		BuildQuadTree(LPGT_CUSTOMVERTEX pHeightMap);
	void		BuildNeighborNode(GtQuadTree* pRoot, LPGT_CUSTOMVERTEX pHeightMap, int iIndexRow);
	bool		SubDivide(void);
	int			GetNeighborIndex(int iCourse, int iIndexRow, int& iCorner_0, int& iCorner_1, int& iCorner_2, int& iCorner_3);
	GtQuadTree*	FindNode(LPGT_CUSTOMVERTEX pHeightMap, int iCorner_0, int iCorner_1, int iCorner_2, int iCorner_3);

public:
	// LOD 
	int			GetLODLevel(LPGT_CUSTOMVERTEX pHeightMap, GtPoint3f* pCamera, double fLODRatio);
	float		GetDistance(GtPoint3f* pV1, GtPoint3f* pV2);
	bool		IsVisible(LPGT_CUSTOMVERTEX pHeightMap, GtPoint3f* pCamera, double fLODRatio);

public:
	// ü ø
	void		FrustumCull(LPGT_CUSTOMVERTEX pHeightMap, GtFrustum *pFrustum);
	int			IsInFrustum(LPGT_CUSTOMVERTEX pHeightMap, GtFrustum *pFrustum);

public:
	// ¿ ε  
	int			GenTriIndex(int iTris, LPVOID pIB, LPGT_CUSTOMVERTEX pHeightMap, GtFrustum *pFrustum, double fLODRatio);
	int			GenerateIndex(LPVOID pIB, LPGT_CUSTOMVERTEX pHeightMap, GtFrustum *pFrustum, double fLODRatio);
};