#pragma once

#include "GtSphere.h"

typedef enum eGT_POOL
{
	GT_POOL_DEFAULT                 = 0,
	GT_POOL_MANAGED                 = 1,
	GT_POOL_SYSTEMMEM               = 2,
	GT_POOL_SCRATCH                 = 3,

	GT_POOL_FORCE_DWORD             = 0x7fffffff
}GT_POOL;

class GtSoftwareRenderDevice;

typedef class GtVertexBuffer
{
	friend GtSoftwareRenderDevice;
public:
	unsigned int	m_uiLength;
	void*			m_pVB;
	GtSphere		m_Sphere;
public:
	bool			Lock(unsigned int OffsetToLock, unsigned int SizeToLock,
						 void** ppbData, unsigned long Flags);
	bool			Unlock(void);
	bool			Release(void);

public:
	GtVertexBuffer(void) {}
	GtVertexBuffer(int iLength);
	~GtVertexBuffer();
}GtVertexBuffer, *LPGTVertexBuffer;